



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>k-近邻算法-手写识别系统</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">k-近邻算法-手写识别系统</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-11 13:29:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>手写数字是32x32的黑白图像。为了能使用KNN分类器，我们需要把32x32的二进制图像转换为1x1024</p>
<h3>1. 将图像转化为向量</h3>
<div>
<pre class="prettyprint linenums">from numpy import *<br />
# 导入科学计算包numpy和运算符模块operator<br />
import operator<br />
from os import listdir</pre>
</div>
<div>
<pre class="prettyprint linenums">def img2vector(filename):<br />
    """<br />
    将图像数据转换为向量<br />
    :param filename: 图片文件 因为我们的输入数据的图片格式是 32 * 32的<br />
    :return: 一维矩阵<br />
    该函数将图像转换为向量：该函数创建 1 * 1024 的NumPy数组，然后打开给定的文件，<br />
    循环读出文件的前32行，并将每行的头32个字符值存储在NumPy数组中，最后返回数组。<br />
    """<br />
    returnVect = zeros((1, 1024))<br />
    fr = open(filename)<br />
    for i in range(32):<br />
        lineStr = fr.readline()<br />
        for j in range(32):<br />
            returnVect[0, 32 * i + j] = int(lineStr[j])<br />
    return returnVect</pre>
</div>
<p>测试：</p>
<div>
<pre class="prettyprint linenums">testVector = img2vector('F:/迅雷下载/machinelearninginaction/Ch02/testDigits/0_13.txt')<br />
testVector[0, 0:31]</pre>
</div>
<pre class="prettyprint linenums">array([0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 1., 1., 1.,<br />
       1., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.])</pre>
<h3>2. KNN分类器</h3>
<div>
<pre class="prettyprint linenums">def classify0(inX, dataSet, labels, k):<br />
    """<br />
    inX: 用于分类的输入向量<br />
    dataSet: 输入的训练样本集<br />
    labels: 标签向量<br />
    k: 选择最近邻居的数目<br />
    注意：labels元素数目和dataSet行数相同；程序使用欧式距离公式.<br />
    """<br />
    # 求出数据集的行数<br />
    dataSetSize = dataSet.shape[0]<br />
    # tile生成和训练样本对应的矩阵，并与训练样本求差<br />
    """<br />
    tile: 列: 3表示复制的行数， 行：1／2 表示对inx的重复的次数<br />
    例：In []: inX = [1, 2, 3]<br />
               tile(inx, (3, 1))

        Out[]: array([[1, 2, 3],<br />
                       [1, 2, 3],<br />
                       [1, 2, 3]])<br />
    """<br />
    # 用inx（输入向量）生成和dataSet类型一样的矩阵，在减去dataSet<br />
    diffMat = tile(inX, (dataSetSize, 1)) - dataSet<br />
    # 取平方<br />
    sqDiffMat = diffMat ** 2<br />
    # 将矩阵的每一行相加<br />
    sqDistances = sqDiffMat.sum(axis=1)<br />
    # 开方<br />
    distances = sqDistances ** 0.5<br />
    # 根据距离排序从小到大的排序，返回对应的索引位置<br />
    # argsort() 是将x中的元素从小到大排列，提取其对应的index（索引），然后输出到y。<br />
    """<br />
    In [] : y = argsort([3, 0, 2, -1, 4, 5])<br />
            print(y[0])<br />
            print(y[5])<br />
    Out[] : 3<br />
            5<br />
    由于最小的数是-1，它的序号是3，因此y[0] = 3, 最大的数是5，它的序号是5，因此y[5] = 5<br />
    """<br />
    sortedDistIndicies = distances.argsort()<br />
    # 2. 选择距离最小的k个点<br />
    classCount = {}<br />
    for i in range(k):<br />
        voteIlabel = labels[sortedDistIndicies[i]]<br />
        classCount[voteIlabel] = classCount.get(voteIlabel, 0) + 1<br />
    sortedClassCount = sorted(classCount.items(), key=operator.itemgetter(1), reverse=True)<br />
    return sortedClassCount[0][0]  </pre>
</div>
<h3>3. 手写数字识别系统的测试代码</h3>
<div>
<pre class="prettyprint linenums">def handwritingClassTest():<br />
    # 1. 导入数据<br />
    hwLabels = []<br />
    trainingFileList = listdir('F:/迅雷下载/machinelearninginaction/Ch02/trainingDigits')  # load the training set<br />
    m = len(trainingFileList)<br />
    trainingMat = zeros((m, 1024))<br />
    # hwLabels存储0～9对应的index位置， trainingMat存放的每个位置对应的图片向量<br />
    for i in range(m):<br />
        fileNameStr = trainingFileList[i]<br />
        fileStr = fileNameStr.split('.')[0]  # take off .txt<br />
        classNumStr = int(fileStr.split('_')[0])<br />
        hwLabels.append(classNumStr)<br />
        # 将 32*32的矩阵-&gt;1*1024的矩阵<br />
        trainingMat[i, :] = img2vector('F:/迅雷下载/machinelearninginaction/Ch02/trainingDigits/%s' % fileNameStr)

    # 2. 导入测试数据<br />
    testFileList = listdir('F:/迅雷下载/machinelearninginaction/Ch02/testDigits')  # iterate through the test set<br />
    errorCount = 0.0<br />
    mTest = len(testFileList)<br />
    for i in range(mTest):<br />
        fileNameStr = testFileList[i]<br />
        fileStr = fileNameStr.split('.')[0]  # take off .txt<br />
        classNumStr = int(fileStr.split('_')[0])<br />
        vectorUnderTest = img2vector('F:/迅雷下载/machinelearninginaction/Ch02/testDigits/%s' % fileNameStr)<br />
        classifierResult = classify0(vectorUnderTest, trainingMat, hwLabels, 3)<br />
        print("the classifier came back with: %d, the real answer is: %d" % (classifierResult, classNumStr))<br />
        if (classifierResult != classNumStr): errorCount += 1.0<br />
    print("\nthe total number of errors is: %d" % errorCount)<br />
    print("\nthe total error rate is: %f" % (errorCount / float(mTest)))</pre>
</div>
<div>
<pre class="prettyprint linenums">handwritingClassTest()</pre>
</div>
<pre class="prettyprint linenums">the classifier came back with: 0, the real answer is: 0<br />
the classifier came back with: 0, the real answer is: 0<br />...</pre>
<pre class="prettyprint linenums">the classifier came back with: 9, the real answer is: 9<br />
the classifier came back with: 9, the real answer is: 9

the total number of errors is: 10

the total error rate is: 0.010571<br />k-近邻算法识别手写数字，错误率在1.1%.改变k的值、修改函数 handwritingClassTest 随机选取训练样本、改变训练样本的数目，都会对k-近邻算法的错误率产生影响。<br />实际上，这个算法的执行效率并不高。因为每个算法需要为每个测试向量做2000次距离计算，每个距离计算包括了1024个维度浮点运算，总计执行900次。<br />而K决策树就是k-近邻的优化版。</pre>
<h3>4. 总结</h3>
<p>k-近邻算法的特点：</p>
<p>1. 是分类数据最简单最有效的算法</p>
<p>2. 必须保存全部数据集，会使用大量存储空间</p>
<p>3. 必须对每个数据计算距离值，非常耗时</p>
<pre class="prettyprint linenums">
</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mn7z6q.html">Hadoop MapReduce执行过程详解（带hadoop例子）</a>
		</li>
						<li><a href="https://www.batexi.com/a/495d630q.html">sk&lowbar;buff封装和解封装网络数据包的过程详解（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p5kvy8.html">IOS第17天&lpar;2&comma;Quartz2D图片剪裁变圆行图，和截屏图片）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvmrxzq.html">js面向对象组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93m1nr8.html">mysql中FIND&lowbar;IN&lowbar;SET的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdnwl09.html">windows客户机连接gerrit的一个报错处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlyej69.html">JS 键值对</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1egxm9.html">字符串和date之间的相互转换方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmmzd09.html">ROS创建工作空间（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j06nmeq.html">SharePoint 2013 error The given assembly name or codebase System&period;ServiceModel&period;dll was invalid</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdnv4z9.html">Group DataList</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz1jle8.html">cocos2dx 3&period;1&period;1移植安卓apk &lpar;lua交叉编译器项目 mac环境&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdpg349.html">关于FlagsAttribute</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdmm4k9.html">ios隐藏键盘的方式简单应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z1rne9.html">install&lowbar;driver&lpar;Oracle&rpar; failed&colon; Can&amp;&num;39&semi;t load &grave;&period;&period;&period;&sol;DBD&sol;Oracle&sol;Oracle&period;so&amp;&num;39&semi; for module DBD&colon;&colon;Oracle</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpgj169.html">中国梦&amp;amp&semi;nbsp&semi;&amp;amp&semi;nbsp&semi;每个农大人的梦</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp324j9.html">PHP编译报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojxp1eq.html">python类与对象-如何让对象支持上下文管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv5gly8.html">openwrt package 依赖关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy2z7n9.html">DNS详解&colon; A记录&comma;子域名&comma;CNAME别名&comma;PTR&comma;MX&comma;TXT&comma;SRV&comma;TTL</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnv274k8.html">Nginx在局域网中使用ip&lowbar;hash负载均衡策略，访问全部分发到同一个后台服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e45dmz9.html">JavaWeb - Servlet教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jmxreq.html">【ARTS】01&lowbar;13&lowbar;左耳听风-20190204~20190210</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jme25q.html">linux驱动 之 module&lowbar;init解析 （上）【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwxngk8.html">从url&lpar;地址栏&rpar;获取参数：Jquery中getUrlParam&lpar;&rpar;方法的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7onxke8.html">InstallShield 静默安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/90revp39.html">thinkphp提示不支持mysqli或者mysql</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv0vnz8.html">Jenkins pipeline概念理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gjgn0q.html">nginx https配置记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gj3z6q.html">前端 ----- 01 -html介绍和head标签</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
